KWONG  ; SOURCE PROGRAM FOR KEEPIT/KBJ-80
 ; COPYRIGHT 1980 BY DENNIS BATHORY KITSZ
 ; THIS VERSION PREPARED FOR KBJ-80 PRODUCT OF
 ; FRANK KWONG, KOKOMO, INDIANA
 ; COPYRIGHT (C) 1980, 1981 BY DENNIS BATHORY KITSZ
 ; ALL RIGHTS RESERVED.  NO PART OF THIS PROGRAM MAY
 ; BE REPRODUCED BY ANY MEANS, ELECTRONIC, ELECTRO-
 ; MECHANICAL, OR IN PRINT, WHETHER BY METHODS IN
 ; USE OR CONCEIVED IN THE FUTURE, WITHOUT SPECIFIC
 ; WRITTEN PERMISSION OF THE AUTHOR.
 INKEYS	EQU	4099H
 PORTFF	EQU	403DH
 KPLACE	EQU	401AH
 SHIFTR	EQU	4019H
 RESTRT	EQU	4004H
 STACKR	EQU	40E8H
 VAREND	EQU	40FDH
 READY	EQU	06CCH
 MEMTOP	EQU	40B1H
 SETPTS	EQU	4000H
 WRTBYT	EQU	0264H
 BYTE	EQU	1D78H
 VIDEO	EQU	3C00H
 	ORG	3039H
 START	LD	HL,(40B1H)
 	LD	DE,(40A0H)
 	LD	B,7
 	DEC	HL
 	DEC	DE
 	DJNZ	$-2
 	LD	(40B1H),HL
 	LD	(40A0H),DE
 	INC	HL
 	PUSH	HL
 	POP	IY
 	LD	A,0C3H
 	LD	(IY+0),A
 	LD	DE,(RESTRT)
 	LD	(IY+1),E
 	LD	(IY+2),D
 	LD	(IY+3),A
 	LD	DE,SKPSTP
 	LD	(IY+4),E
 	LD	(IY+5),D
 GRINS	INC	HL
 	INC	HL
 	INC	HL
 	LD	(RESTRT),HL
 	XOR	A
 	LD	(SHIFTR),A
 RSLVII	CALL	01C9H
 	CALL	1B61H
 	LD	HL,0111H
 	CALL	28A7H
 	JP	READY
 KBPFIX	LD	HL,4036H
 	LD	BC,3801H
 	LD	D,0
 KEYPRS	LD	A,(BC)
 	LD	E,A
 	AND	E
 	JR	NZ,STROKE
 	LD	(HL),A
 RECHEK	INC	D
 	INC	L
 	RLC	C
 	LD	A,C
 	SUB	80H
 	JR	NZ,KEYPRS
 	LD	B,7
 CLRMEM	DEC	L
 	ADD	A,(HL)
 	DJNZ	CLRMEM
 	AND	A
 	LD	A,0
 	RET	NZ
 	LD	(KPLACE),A
 	RET
 STROKE	AND	(HL)
 	JR	Z,FOUND
 	LD	A,(INKEYS)
 	AND	A
 	JR	NZ,RECHEK
 	LD	A,(KPLACE)
 	INC	A
 	LD	(KPLACE),A
 	CP	0FFH
 	JR	Z,DECA
 	PUSH	BC
 	LD	B,0FFH
 TMWSTE	DJNZ	TMWSTE
 	POP	BC
 	JR	RECHEK
 DECA	DEC	A
 	LD	(KPLACE),A
 	LD	A,E
 FOUND	LD	(HL),E
 	LD	A,D
 	RLCA
 	RLCA
 	RLCA
 	LD	D,A
 	LD	C,1
 BACKUP	LD	A,C
 	AND	E
 	JR	NZ,AROUND
 	INC	D
 	RLC	C
 	JR	BACKUP
 AROUND	LD	A,(3880H)
 	LD	B,A
 	LD	A,D
 	ADD	A,40H
 	CP	60H
 	JR	NC,Z0429H
 	LD	D,A
 	LD	A,(3840H)
 	AND	10H
 	JR	NZ,CNTROL
 	LD	A,D
 	RRC	B
 	JR	C,GOAWAY
 	ADD	A,20H
 	JR	GOAWAY
 CNTROL	LD	A,D
 	SUB	40H
 	JR	GOAWAY
 Z0429H	SUB	70H
 	JR	NC,Z043DH
 	ADD	A,40H
 	CP	3CH
 	JR	C,Z0435H
 	XOR	10H
 Z0435H	RRC	B
 	JR	NC,GOAWAY
 	XOR	10H
 	JR	GOAWAY
 Z043DH	RLCA
 	RRC	B
 	JR	NC,Z0443H
 	INC	A
 Z0443H	LD	HL,TABLET
 	LD	C,A
 	LD	B,0
 	ADD	HL,BC
 	LD	A,(HL)
 	JR	GOAWAY
 TABLET	DEFW	0D0DH
 	DEFW	1F1FH
 	DEFW	0101H
 	DEFW	1B5BH
 	DEFW	000AH
 	DEFW	1808H
 	DEFW	1909H
 	DEFW	2020H
 GOAWAY	LD	D,A
 	LD	A,(3810H)
 	CP	1
 	JR	NZ,BLEEEP
 	LD	A,(3880H)
 	CP	1
 	JR	NZ,BLEEEP
 	LD	A,(SHIFTR)
 	XOR	1
 	LD	(SHIFTR),A
 	LD	BC,500H
 	CALL	0060H
 	RET
 BLEEEP	LD	BC,180H
 	CALL	0060H
 	LD	A,D
 	PUSH	BC
 	PUSH	AF
 	LD	B,40H
 	LD	A,(PORTFF)
 	AND	0FDH
 	LD	H,A
 	OR	2
 	LD	L,A
 BEEPER	LD	A,L
 	OUT	(0FFH),A
 	LD	A,H
 	OUT	(0FFH),A
 	PUSH	BC
 	LD	B,40H
 FREQCY	DJNZ	FREQCY
 	POP	BC
 	DJNZ	BEEPER
 	POP	AF
 	POP	BC
 	JP	0452H
 SKPSTP	EQU	$
 BEGIN	EX	(SP),HL
 	LD	A,L
 	CP	5BH
 	JR	NZ,NOTRDY
 	LD	A,H
 	CP	1DH
 NOTRDY	EX	(SP),HL
 	JP	NZ,BYTE
 	CALL	BYTE
 	CP	0CFH
 	JR	Z,OKSTAR
 	DEC	HL
 	JP	(IY)
 OKSTAR	CALL	BYTE
 	JP	Z,SYNERR
 	CP	0ADH
 	JR	Z,SAVER
 	CP	0BBH
 	JR	Z,RENEW
 	CP	0A2H
 	JP	Z,OPENER
 	CP	0CCH
 	JP	Z,STPSET
 	CP	0C8H
 	JP	Z,MEMSET
 	CP	0F2H
 	JR	Z,INBEEP
 	CP	0B2H
 	JR	Z,LOWCAS
 	CP	0A0H
 	JR	Z,BIPOFF
 	CP	0AAH
 	JR	Z,UPPPER
 	CP	08BH
 	JR	Z,MENU
 SYNERR	JP	1997H
 MENU	LD	HL,INTRO1
 	CALL	28A7H
 	LD	HL,INTRO2
 	CALL	28A7H
 	LD	HL,INTRO3
 	CALL	28A7H
 	LD	HL,INTRO4
 	CALL	28A7H
 	JR	READYX
 LOWCAS	LD	A,1
 	LD	(SHIFTR),A
 	LD	HL,LOWER
 	LD	(401EH),HL
 	JR	READYX
 UPPPER	LD	HL,0458H
 	LD	(401EH),HL
 	JR	READYX
 BIPOFF	LD	HL,03E3H
 	LD	(4016H),HL
 	JR	READYX
 INBEEP	LD	HL,KBPFIX
 	LD	(4016H),HL
 READYX	JP	READY
 RENEW	LD	DE,(40A4H)
 	LD	A,0FFH
 	LD	(DE),A
 	CALL	1AFCH
 	INC	HL
 	LD	(40F9H),HL
 	LD	SP,(40E8H)
 	JP	RSLVII
 SAVER	CALL	BYTE
 	CP	0D0H
 	JR	NZ,SYNERR
 	CALL	BYTE
 	CP	8EH
 	JP	NZ,MACH
 	CALL	BYTE
 	CP	022H
 	JR	NZ,SYNERR
 	CALL	BYTE
 	JP	Z,24A0H
 	PUSH	HL
 	PUSH	AF
 	PUSH	DE
 	PUSH	BC
 	XOR	A
 	CALL	0212H
 	CALL	0287H
 	LD	A,55H
 	CALL	WRTBYT
 	LD	B,06
 	DEC	HL
 NAMES	CALL	BYTE
 	CP	22H
 	JR	Z,NEXTBT
 	CALL	WRTBYT
 	DJNZ	NAMES
 	JR	DUMP
 NEXTBT	LD	A,20H
 	CALL	WRTBYT
 	DJNZ	NEXTBT
 DUMP	LD	HL,SETPTS
 	CALL	OUTSEQ
 	CALL	OUTSEQ
 	LD	B,0E9H
 	CALL	OUTSEQ
 	LD	DE,(VAREND)
 	LD	A,E
 	SUB	L
 	LD	B,A
 	CALL	OUTSEQ
 NXTPGE	LD	A,H
 	DEC	A
 	CP	D
 	JR	Z,FINSH1
 	CALL	OUTSEQ
 	JR	NXTPGE
 FINSH1	LD	HL,(STACKR)
 	LD	DE,(MEMTOP)
 	INC	DE
 	LD	A,E
 	SUB	L
 	LD	B,A
 	CALL	OUTSEQ
 NXTBCH	LD	A,H
 	DEC	A
 	CP	D
 	JR	Z,KEEPIT
 	CALL	OUTSEQ
 	JR	NXTBCH
 KEEPIT	LD	HL,(40B1H)
 	LD	B,10H
 	CALL	OUTSEQ
 	LD	HL,VIDEO
 	LD	B,4
 CDEF	PUSH	BC
 	CALL	PREOUT
 	POP	BC
 	DJNZ	CDEF
 	LD	A,78H
 	CALL	WRTBYT
 	LD	A,0CCH
 	CALL	WRTBYT
 	LD	A,06
 	CALL	WRTBYT
 	POP	BC
 	POP	DE
 	POP	AF
 	POP	HL
 	JP	READY
 PREOUT	LD	B,0
 OUTSEQ	LD	A,3CH
 	CALL	WRTBYT
 	LD	A,B
 	CALL	WRTBYT
 	LD	A,L
 	LD	C,A
 	CALL	WRTBYT
 	LD	A,C
 	ADD	A,H
 	LD	C,A
 	LD	A,H
 	CALL	WRTBYT
 WRTPGE	LD	A,C
 	ADD	A,(HL)
 	LD	C,A
 	LD	A,(HL)
 	CALL	WRTBYT
 	INC	HL
 	DJNZ	WRTPGE
 	LD	A,C
 	CALL	WRTBYT
 	RET
 OPENER	CALL	BYTE
 	CP	22H
 	JP	NZ,SYNERR
 	PUSH	HL
 	CALL	XX99
 	CALL	01C9H
 	JR	NEXT99
 CONTNT	LD	A,D
 	LD	HL,3C40H
 	AND	0F0H
 	CALL	RRRRS
 	LD	A,D
 	AND	0FH
 	CALL	HEXASC
 	LD	(HL),A
 	INC	HL
 	LD	A,E
 	AND	0F0H
 	CALL	RRRRS
 	LD	A,E
 	AND	0FH
 	CALL	HEXASC
 	LD	(HL),A
 	LD	HL,3C80H
 	LD	B,10H
 CONT02	LD	A,(DE)
 	AND	0F0H
 	CALL	RRRRS
 	LD	A,(DE)
 	AND	0FH
 	CALL	HEXASC
 	LD	(HL),A
 	INC	HL
 	INC	HL
 	INC	DE
 	DJNZ	CONT02
 	LD	B,10H
 	PUSH	BC
 	DEC	DE
 	DJNZ	$-1
 	POP	BC
 	PUSH	BC
 	LD	HL,3CC0H
 BBBA	LD	A,(DE)
 	LD	(HL),A
 	INC	HL
 	INC	HL
 	INC	HL
 	INC	DE
 	DJNZ	BBBA
 	POP	BC
 	DEC	DE
 	DJNZ	$-1
 	RET
 NEXT99	CALL	CONTNT
 EDITOR	LD	A,(3840H)
 	RLA
 	RLA
 	JR	NC,AAAA
 	INC	DE
 	JR	STNDRD
 AAAA	RLA
 	JR	NC,AAAB
 	DEC	DE
 	JR	STNDRD
 AAAB	LD	B,10H
 	RLA
 	JR	NC,AAAC
 	DEC	DE
 	DJNZ	$-1
 	JR	STNDRD
 AAAC	RLA
 	JR	NC,BREEK
 	INC	DE
 	DJNZ	$-1
 	JR	STNDRD
 BREEK	RLA
 	JR	NC,AAAD
 	POP	HL
 	JP	READY
 AAAD	LD	HL,3D01H
 	LD	(HL),5FH
 	DEC	HL
 	LD	(HL),5FH
 	LD	B,2
 AAAE	PUSH	DE
 	PUSH	HL
 	CALL	0049H
 	POP	HL
 	POP	DE
 	CP	47H
 	JR	NC,EDITOR
 	CP	30H
 	JR	C,EDITOR
 	CP	3AH
 	JR	C,AAAF
 	CP	40H
 	JR	C,EDITOR
 AAAF	LD	(HL),A
 	INC	HL
 	DJNZ	AAAE
 	DEC	HL
 	CALL	ASCHEX
 	LD	C,A
 	DEC	HL
 	CALL	LLLLS
 	ADD	A,C
 	LD	(DE),A
 	INC	DE
 STNDRD	CALL	CONTNT
 	CALL	DELAY
 	JR	EDITOR
 ASCHEX	LD	A,(HL)
 	SUB	30H
 	CP	0AH
 	RET	C
 	SUB	7
 	RET
 HEXASC	ADD	A,30H
 	CP	3AH
 	RET	C
 	ADD	A,7
 	RET
 RRRRS	RRCA
 	RRCA
 	RRCA
 	RRCA
 	CALL	HEXASC
 	LD	(HL),A
 	INC	HL
 	RET
 LLLLS	CALL	ASCHEX
 	RLCA
 	RLCA
 	RLCA
 	RLCA
 	RET
 DELAY	LD	BC,2000H
 	CALL	0060H
 	RET
 XX99	LD	B,4
 SSSS	CALL	BYTE
 	PUSH	AF
 	DJNZ	SSSS
 	POP	AF
 	LD	(HL),A
 	CALL	ASCHEX
 	LD	E,A
 	POP	AF
 	LD	(HL),A
 	CALL	LLLLS
 	ADD	A,E
 	LD	E,A
 	POP	AF
 	LD	(HL),A
 	CALL	ASCHEX
 	LD	D,A
 	POP	AF
 	LD	(HL),A
 	CALL	LLLLS
 	ADD	A,D
 	LD	D,A
 	RET
 MACH	CP	0A2H
 	JR	NZ,SYN2
 	CALL	BYTE
 	SUB	22H
 SYN2	JP	NZ,SYNERR
 	CALL	0212H
 	CALL	0287H
 	LD	A,55H
 	CALL	WRTBYT
 	LD	B,06
 NAME99	CALL	BYTE
 	CP	2CH
 	JR	Z,NXTB99
 	CALL	WRTBYT
 	DJNZ	NAME99
 	JR	DUMP99
 NXTB99	LD	A,20H
 	CALL	WRTBYT
 	DJNZ	NXTB99
 DUMP99	CALL	BYTE
 	CP	2CH
 	JR	NZ,SYN2
 	CALL	XX99
 	PUSH	DE
 	CALL	BYTE
 	CP	2CH
 	JR	Z,TTTT
 	POP	DE
 	XOR	A
 	JP	24A0H
 TTTT	CALL	XX99
 	PUSH	DE
 	CALL	BYTE
 	CP	2CH
 	JR	Z,EXECU
 	LD	HL,06CCH
 	LD	(407EH),HL
 	JR	WRIT99
 EXECU	CALL	XX99
 	LD	(407EH),DE
 WRIT99	POP	HL
 	POP	DE
 	PUSH	DE
 	LD	A,D
 	CPL
 	LD	D,A
 	LD	A,E
 	CPL
 	LD	E,A
 	ADD	HL,DE
 	INC	HL
 	INC	HL
 	PUSH	HL
 	POP	DE
 	POP	HL
 	LD	B,E
 	INC	B
 	INC	D
 LP99	PUSH	DE
 	CALL	OUTSEQ
 	POP	DE
 	DEC	D
 	JR	NZ,LP99
 	LD	A,78H
 	CALL	WRTBYT
 	LD	A,(407EH)
 	CALL	WRTBYT
 	LD	A,(407FH)
 	CALL	WRTBYT
 	JR	PREP2
 STPSET	PUSH	AF
 	PUSH	HL
 	CALL	BYTE
 	OR	A
 	JR	NZ,IIII
 	LD	(IY+4),SKPSTP&00FFH
 	LD	(IY+5),SKPSTP&0FF00H<-8
 	POP	HL
 	POP	AF
 	JR	PREP2
 IIII	SUB	30H
 	RLA
 	RLA
 	RLA
 	RLA
 	LD	D,A
 	CALL	BYTE
 	OR	A
 	JR	NZ,ABCD
 	POP	HL
 	POP	AF
 SYN3	JP	SYNERR
 ABCD	SUB	30H
 	ADD	A,D
 	LD	D,A
 	LD	(IY+4),JMPPOS&00FFH
 	LD	(IY+5),JMPPOS&0FF00H<-8
 	LD	(IY+6),D
 	POP	HL
 	POP	AF
 PREP2	JP	READY
 JMPPOS	EQU	$
 	PUSH	AF
 	PUSH	BC
 LUPER	LD	A,(3880H)
 	AND	A
 	JR	Z,LUPER
 	LD	C,A
 	LD	B,(IY+6)
 	CALL	0060H
 	POP	BC
 	POP	AF
 	JP	BEGIN
 MEMSET	CALL	BYTE
 	CP	22H
 	JR	NZ,SYN3
 	CALL	XX99
 	LD	HL,4400H
 	XOR	A
 	SBC	HL,DE
 	JP	NC,197AH
 	PUSH	DE
 	POP	HL
 	LD	B,7
 	INC	HL
 	DJNZ	$-1
 	LD	A,(HL)
 	LD	B,A
 	CPL
 	LD	(HL),A
 	CP	(HL)
 	JP	NZ,197AH
 	LD	(HL),B
 	LD	(40B1H),DE
 	PUSH	IY
 	POP	HL
 	INC	DE
 	PUSH	DE
 	POP	IY
 	LD	BC,7
 	LDIR
 	PUSH	IY
 	POP	HL
 	LD	B,32H
 STRING	DEC	DE
 	DJNZ	STRING
 	LD	(40A0H),DE
 	JP	GRINS
 LOWER	PUSH	AF
 	LD	A,(SHIFTR)
 	CP	1
 	JR	Z,LOWER1
 	POP	AF
 	JP	0458H
 LOWER1	POP	AF
 	LD	L,(IX+3)
 	LD	H,(IX+4)
 	JP	C,049AH
 	LD	A,(IX+5)
 	OR	A
 	JR	Z,GETCHR
 	LD	(HL),A
 GETCHR	LD	A,C
 	CP	20H
 	JP	C,0506H
 	CP	80H
 	JP	NC,04A6H
 	JP	047DH
 INTRO1	DEFM	'*FIX = SET DEBOUNCE/BEEP/AUTOREPEAT'
 	DEFB	0AH
 	DEFM	'*KILL = RESET TO NORMAL KEYBOARD'
 	DEFB	0AH
 	DEFM	'*MEM = RESET MEMORY SIZE (NOTE 1)
 	DEFB	0DH
 	DEFB	00H
 INTRO2	DEFM	'*PRINT = LOWERCASE KEYBOARD/DISPLAY ON'
 	DEFB	0AH
 	DEFM	'*OUT = LOWERCASE KEYBOARD/DISPLAY OFF'
 	DEFB	0AH
 	DEFM	'*NEW = RESTORE PROGRAM VICTIM OF NEW'
 	DEFB	0AH
 	DEFM	'*OPEN = HEX/ASCII/GRAPHICS MONITOR (NOTE 1)'
 	DEFB	0DH
 	DEFB	00H
 INTRO3	DEFM	'*SAVE/RUN = SAVE RUNNING PROGRAM (NOTE 2)'
 	DEFB	0AH
 	DEFM	'*SAVE/OPEN = MEMORY BLOCK SAVE (NOTE 3)'
 	DEFB	0AH
 	DEFM	'*STEPXX = SINGLE STEPPER ON, XX = DELAY'
 	DEFB	0AH
 	DEFM	'*STEP = SINGLE STEPPER OFF'
 	DEFB	0DH
 	DEFB	00
 INTRO4	DEFM	'NOTE 1.  REQUIRES 4-CHARACTER HEX VALUE IN QUOTES.'
 	DEFB	0AH
 	DEFM	'NOTE 2.  REQUIRES 6-CHARACTER NAME IN QUOTES.'
 	DEFB	0AH
 	DEFM	'NOTE 3.  SAME AS ABOVE PLUS HEX START, END, OPTIONAL ENTRY'
 	DEFB	0DH
 	DEFB	00H
 	END	START
